<template>
  <header v-click-outside="hideSidebar" ref="Header" style="background-color: #232323;" :class="{isHeaderClassToScroll}" class="shadow-lg">
    <div class="container py-8 flex justify-between items-center">
      <div class="text-xl cursor-pointer flex items-center font-bold text-white">
        <div @click.prevent="showSidebar" ref="Burger" class="mr-4 w-7 h-4 flex items-center"><img class="w-full" width="24" height="24" src="../assets/images/icons/menu.png" alt=""></div>
        <router-link :to="{name: 'Index'}">
          PHOTO<span class="text-red-500 ml-1">SHOPPING</span>
        </router-link>
      </div>
      <div class="flex cursor-pointer header-router-nav">
        <router-link :to="{name: 'Index'}" @click.prevent="hideSidebar" :class="{'active-header-address':$route.name === 'Index'}" class="mx-2 hidden sm:block">Главная</router-link>
        <router-link :to="{name: 'Shop', params: {category: '0'}}" @click.prevent="hideSidebar" :class="{'active-header-address':$route.name === 'Shop'}" class="mx-2 hidden sm:block">Товары</router-link>
        <router-link :to="{name: 'About'}" @click.prevent="hideSidebar" :class="{'active-header-address':$route.name === 'About'}" class="mx-2 hidden sm:block">О нас</router-link>
        <router-link :to="{name: 'Contacts'}" @click.prevent="hideSidebar" :class="{'active-header-address':$route.name === 'Contacts'}" class="mx-2 hidden sm:block">Контакты</router-link>
        <a href="whatsapp://wa.me/79886126261" class="mx-2 flex items-center text-xs sm:text-sm">
          +79886126261
          <img width="24" height="24" src="../assets/images/icons/whatsapp-min.png" alt="" class="ml-1">
        </a>
        <router-link v-if="1===2" :to="{name: 'Delivery'}" @click.prevent="hideSidebar" :class="{'active-header-address':$route.name === 'Delivery'}" class="mx-2 hidden sm:block">Доставка и оплата</router-link>
      </div>
    </div>
    <transition name="v-transition-sidebar" mode="out-in">
      <div v-if="isSidebar" :class="{isHeaderClassToScroll}" class="sidebar shadow-lg">
        <div v-if="!user" class="w-full flex flex-col">
          <div @click="isModal = 'signIn'" class="button">Вход</div>
          <div @click="isModal = 'sign'" class="button">Регистрация</div>
        </div>
        <Avatar v-if="user" :button="false" class="mx-auto my-6" style="width: 160px"/>
        <div v-if="user" class="w-full flex flex-col">
          <router-link :to="{name: 'Profile'}" @click.prevent="hideSidebar" class="button">Профиль</router-link>
          <router-link :to="{name: 'Orders'}" @click.prevent="hideSidebar" class="button">История заказов</router-link>
          <div class="button" @click="signOut" @click.prevent="showSidebar">Выйти</div>
        </div>
        <div class="flex flex-col connect">
          <p class="text-white text-3xl text-center my-10">Связь с нами</p>
          <div class="flex w-full">
            <a href="whatsapp://wa.me/79886126261" class="flex flex-col items-center w-1/2 cursor-pointer">
              <img class="w-1/6" src="../assets/images/icons/whatsapp.png" alt="">
              <p class="text-white">whatsapp</p>
            </a>
            <a href="tel:+79886126261" class="flex flex-col items-center w-1/2 cursor-pointer">
              <img class="w-1/6" src="../assets/images/icons/phone.png" alt="">
              <p class="text-white">Телефон</p>
            </a>
            <a href="mailto:info@foto09.ru" class="flex flex-col items-center w-1/2 cursor-pointer">
              <img class="w-1/6" src="../assets/images/icons/email.png" alt="">
              <p class="text-white">Почта</p>
            </a>
          </div>
        </div>
      </div>
    </transition>
    <Modal v-if="isModal.length" @close="isModal = ''" :is-confirm="false" :is-close="false">
      <template v-slot:body>
        <Auth :signIn="isModal === 'signIn'" :sign="isModal === 'sign'"/>
      </template>
    </Modal>
  </header>
</template>

<script>
import {computed, onMounted, ref} from 'vue'
import { supabase } from "../supabase"
import {useStore} from "vuex";
import Modal from "./Modal.vue";
import LoadsSpinner from "./Loads-spinner.vue";
import Avatar from "./Avatar.vue";
import Auth from "./Auth.vue";
export default {
  name: "Header",
  components: {Auth, Avatar, LoadsSpinner, Modal},
  setup() {
    const store = useStore()
    let user = computed(function () {
      return store.state.user
    });

    const isHeaderClassToScroll = ref(false)
    const isSidebar = ref(false)
    const Header = ref(null)
    const Burger = ref(null)
    const isModal = ref('')
    const loading = ref(false)


    // SIGN OUT
    async function signOut() {
      try {
        loading.value = true
        user = null
        let { error } = await supabase.auth.signOut()
        if (error) throw error
      } catch (error) {
        console.log(error)
      } finally {
        loading.value = false
      }
    }

    // SIDEBAR
    function handle() {
      document.body.addEventListener('scroll', (e) => {
        const mainSection = document.getElementById('section-router-view')
        const scrollTop = document.body.scrollTop
        isHeaderClassToScroll.value = scrollTop > 80;
        if (isHeaderClassToScroll.value) mainSection.classList.add('active')
        else mainSection.classList.remove('active')
      });
    }
    // SHOW
    function showSidebar() {
      if (isSidebar.value) hideSidebar()
      else {
        if (!isHeaderClassToScroll.value) document.getElementById('section-router-view').classList.add('active')
        document.getElementById('sidebar-active').classList.add('active')
        Header.value.style.position = 'absolute'
        Header.value.style.top = '0'
        Header.value.style.width = '100%'
        isSidebar.value = true
      }
    }

    // HIDE SIDEBAR
    function hideSidebar() {
      isSidebar.value = false
      Header.value.style.position = 'initial'
      document.getElementById('section-router-view').classList.remove('active')
      document.getElementById('sidebar-active').classList.remove('active')
    }

    onMounted(() => {
      handle()
    })

    return {
      isHeaderClassToScroll, isSidebar, Header,
      Burger, isModal, loading,
      user,
      signOut, showSidebar, hideSidebar
    }
  }
}
</script>

<style scoped lang="scss">
header {
  transition: all 0.4s ease-in;
  z-index: 20;
}
header.isHeaderClassToScroll {
  position: fixed!important;
  top: 0;
  height: 60px;
  width: 100%;
  opacity: .6;
  .container {
    padding: 0;
  }
  &:hover {
    opacity: 1;
  }
}
.sidebar {
  position: fixed;
  width: 40%;
  padding: 0 15px;
  @media (max-width: 680px) {
    width: 70%;
  }
  height: calc(100% - 92px);
  &.isHeaderClassToScroll {
    height: calc(100% - 60px);
  }
  left: 0;
  opacity: 1;
  background-color: #232323;
  z-index: 10;
  .connect {
    width: 100%;
    position: absolute;
    bottom: 40px;
    left: 50%;
    transform: translate(-50%, 0%);
  }
}
.header-router-nav {
  a {
    transition: all .3s ease;
    opacity: 0.6;
    color: white !important;
    &.active-header-address {
      position: relative;
      opacity: 1;
      &:before {
        content: '';
        position: absolute;
        border: 2px solid white;
        width: 100%;
        bottom: -5px;
      }
    }
    &:hover {
      opacity: 1;
    }
    @media (max-width: 400px) {
      min-width: 110px;
    }
  }
}
label.error {
  color: darkred;
  input {
    border: 1px solid darkred;
    &:focus-visible {
      outline: 1.5px solid darkred;
    }
  }
}
label {
  position: relative;
  .sign-in-error-message {
    position: absolute;
    left: 50%;
    font-size: 11px;
    top: -5px;
    width: fit-content;
    color: darkred;
    padding: 5px;
    background: #3d3d3d;
    border-radius: 3px;
    &:before {
      content: '▼';
      color: #3d3d3d;
      position: absolute;
      left: 50%;
      transform: translate(-50%, calc(100% - 1px));
    }
  }
}

// Анимация VUE
.v-transition-sidebar-enter {
  opacity: 0;
}
.v-transition-sidebar-enter-active {
  transform: translateX(-650px);
  transition: all .2s ease-in-out;
}
.v-transition-sidebar-enter-to {
  transform: translateX(0px);
  opacity: 1;
}
.v-transition-sidebar-leave {
  opacity: 1;
}
.v-transition-sidebar-leave-active {
  transition: transform .4s ease, opacity .4s;
}
.v-transition-sidebar-leave-to {
  transform: translateX(-350px);
  opacity: 0;
}
.v-transition-sidebar-move {
  transition: transform .4s;
}
</style>
